% x=kktsolve(A,b)
% x=kktsolve(A,b,options)
%
% Calls KKTDirect to solve A*x=b.
% If options is given and is zero, than it uses a pointwise uplooking
% method; otherwise it uses a supernodal leftlooking method.

function x=kktsolve(A,b,options)

if any(A-A')
  error('Input matrix is not symmetric');
end
if nargin<3
   x=kktsolve_mex(A,b);
else
   x=kktsolve_mex(A,b,options);
end
