#include <stdio.h>

int u_index(int i, int j, int nx)
{ return i-1+j*(nx-1); }

int v_index(int i, int j, int nx)
{ return (nx-1)*nx + i+(j-1)*nx; }

int p_index(int i, int j, int nx)
{ return (nx-1)*nx + nx*(nx-1) + i+j*nx; }


int main(int argc, char **argv)
{
   int nx=30, i, j;
   int n, c;

   if(argc>=2){
      sscanf(argv[1], "%d", &nx);
   }

   n=(nx-1)*nx+nx*(nx-1)+nx*nx - 1; // remove one pressure at the end to make it nonsingular
   printf("%d\n\n", n);

   // do column starts
   c=0;
   printf("0");
   // u variables
   for(j=0; j<nx; ++j) for(i=1; i<nx; ++i){
      ++c; // for diagonal entry
      c+=2; // for left and right pressure neighbours
      if(i>1) ++c; // left u neighbour
      if(i<nx-1) ++c; // right u neighbour
      if(j>0) ++c; // bottom u neighbour
      if(j<nx-1) ++c; // top u neighbour
      if(i==nx-1 && j==nx-1) --c; // eliminate missing pressure in corner
      printf(" %d", c);
   }
   printf("\n");
   // v variables
   for(j=1; j<nx; ++j) for(i=0; i<nx; ++i){
      ++c; // for diagonal entry
      c+=2; // for bottom and top pressure neighbours
      if(i>0) ++c; // left v neighbour
      if(i<nx-1) ++c; // right v neighbour
      if(j>1) ++c; // bottom v neighbour
      if(j<nx-1) ++c; // top v neighbour
      if(i==nx-1 && j==nx-1) --c; // eliminate missing pressure in corner
      printf(" %d", c);
   }
   printf("\n");
   // p variables
   for(j=0; j<nx; ++j) for(i=0; i<nx; ++i){
      if(i==nx-1 && j==nx-1) continue; // eliminate corner pressure
      if(i>0) ++c; // for left u neighbour
      if(i<nx-1) ++c; // for right u neighbour
      if(j>0) ++c; // for bottom v neighbour
      if(j<nx-1) ++c; // for top v neighbour
      printf(" %d", c);
   }
   printf("\n\n");

   // do row indices
   // u columns
   for(j=0; j<nx; ++j) for(i=1; i<nx; ++i){
      if(j>0) printf(" %d", u_index(i,j-1,nx));
      if(i>1) printf(" %d", u_index(i-1,j,nx));
      printf(" %d", u_index(i,j,nx));
      if(i<nx-1) printf(" %d", u_index(i+1,j,nx));
      if(j<nx-1) printf(" %d", u_index(i,j+1,nx));
      if(i==nx-1 && j==nx-1)
         printf(" %d\n", p_index(i-1,j,nx)); // skip missing pressure
      else
         printf(" %d %d\n", p_index(i-1,j,nx), p_index(i,j,nx));
   }
   printf("\n");
   // v columns
   for(j=1; j<nx; ++j) for(i=0; i<nx; ++i){
      if(j>1) printf(" %d", v_index(i,j-1,nx));
      if(i>0) printf(" %d", v_index(i-1,j,nx));
      printf(" %d", v_index(i,j,nx));
      if(i<nx-1) printf(" %d", v_index(i+1,j,nx));
      if(j<nx-1) printf(" %d", v_index(i,j+1,nx));
      if(i==nx-1 && j==nx-1)
         printf(" %d\n", p_index(i,j-1,nx)); // skip missing pressure
      else
         printf(" %d %d\n", p_index(i,j-1,nx), p_index(i,j,nx));
   }
   printf("\n");
   // p columns
   for(j=0; j<nx; ++j) for(i=0; i<nx; ++i){
      if(i==nx-1 && j==nx-1) continue; // skip missing pressure
      if(i>0) printf(" %d", u_index(i,j,nx));
      if(i<nx-1) printf(" %d", u_index(i+1,j,nx));
      if(j>0) printf(" %d", v_index(i,j,nx));
      if(j<nx-1) printf(" %d", v_index(i,j+1,nx));
      printf("\n");
   }
   printf("\n");

   // and finally numerical entries
   // u columns
   for(j=0; j<nx; ++j) for(i=1; i<nx; ++i){
      if(j>0) printf(" -1");
      if(i>1) printf(" -1");
      printf(" 4");
      if(i<nx-1) printf(" -1");
      if(j<nx-1) printf(" -1");
      if(i==nx-1 && j==nx-1)
         printf(" 1\n"); // skip missing pressure
      else
         printf(" 1 -1\n");
   }
   printf("\n");
   // v columns
   for(j=1; j<nx; ++j) for(i=0; i<nx; ++i){
      if(j>1) printf(" -1");
      if(i>0) printf(" -1");
      printf(" 4");
      if(i<nx-1) printf(" -1");
      if(j<nx-1) printf(" -1");
      if(i==nx-1 && j==nx-1)
         printf(" 1\n"); // skip missing pressure
      else
         printf(" 1 -1\n");
   }
   printf("\n");
   // p columns
   for(j=0; j<nx; ++j) for(i=0; i<nx; ++i){
      if(i==nx-1 && j==nx-1) continue; // skip missing pressure
      if(i>0) printf(" -1");
      if(i<nx-1) printf(" 1");
      if(j>0) printf(" -1");
      if(j<nx-1) printf(" 1");
      printf("\n");
   }
   printf("\n");

   return 0;
}

