#include <stdio.h>

int u_index(int i, int j, int k, int nx)
{ return i-1+(nx-1)*(j+nx*k); }

int v_index(int i, int j, int k, int nx)
{ return (nx-1)*nx*nx + i+nx*(j-1+(nx-1)*k); }

int w_index(int i, int j, int k, int nx)
{ return 2*(nx-1)*nx*nx + i+nx*(j+nx*(k-1)); }

int p_index(int i, int j, int k, int nx)
{ return 3*(nx-1)*nx*nx + i+nx*(j+nx*k); }


int main(int argc, char **argv)
{
   int nx=30, i, j, k;
   int n, c;

   if(argc>=2){
      sscanf(argv[1], "%d", &nx);
   }

   n=3*(nx-1)*nx*nx+nx*nx*nx;
   printf("%d\n\n", n);

   // do column starts
   c=0;
   printf("0");
   // u variables
   for(k=0; k<nx; ++k) for(j=0; j<nx; ++j) for(i=1; i<nx; ++i){
      ++c; // for diagonal entry
      c+=2; // for left and right pressure neighbours
      if(i>1) ++c; // left u neighbour
      if(i<nx-1) ++c; // right u neighbour
      if(j>0) ++c; // bottom u neighbour
      if(j<nx-1) ++c; // top u neighbour
      if(k>0) ++c; // in u neighbour
      if(k<nx-1) ++c; // out u neighbour
      printf(" %d", c);
   }
   printf("\n");
   // v variables
   for(k=0; k<nx; ++k) for(j=1; j<nx; ++j) for(i=0; i<nx; ++i){
      ++c; // for diagonal entry
      c+=2; // for bottom and top pressure neighbours
      if(i>0) ++c; // left v neighbour
      if(i<nx-1) ++c; // right v neighbour
      if(j>1) ++c; // bottom v neighbour
      if(j<nx-1) ++c; // top v neighbour
      if(k>0) ++c; // in v neighbour
      if(k<nx-1) ++c; // out v neighbour
      printf(" %d", c);
   }
   printf("\n");
   // w variables
   for(k=1; k<nx; ++k) for(j=0; j<nx; ++j) for(i=0; i<nx; ++i){
      ++c; // for diagonal entry
      c+=2; // for in and out pressure neighbours
      if(i>0) ++c; // left w neighbour
      if(i<nx-1) ++c; // right w neighbour
      if(j>0) ++c; // bottom w neighbour
      if(j<nx-1) ++c; // top w neighbour
      if(k>1) ++c; // in w neighbour
      if(k<nx-1) ++c; // out w neighbour
      printf(" %d", c);
   }
   printf("\n");
   // p variables
   for(k=0; k<nx; ++k) for(j=0; j<nx; ++j) for(i=0; i<nx; ++i){
      if(i>0) ++c; // for left u neighbour
      if(i<nx-1) ++c; // for right u neighbour
      if(j>0) ++c; // for bottom v neighbour
      if(j<nx-1) ++c; // for top v neighbour
      if(k>0) ++c; // for in w neighbour
      if(k<nx-1) ++c; // for out w neighbour
      printf(" %d", c);
   }
   printf("\n\n");

   // do row indices
   // u columns
   for(k=0; k<nx; ++k) for(j=0; j<nx; ++j) for(i=1; i<nx; ++i){
      if(k>0) printf(" %d", u_index(i,j,k-1,nx));
      if(j>0) printf(" %d", u_index(i,j-1,k,nx));
      if(i>1) printf(" %d", u_index(i-1,j,k,nx));
      printf(" %d", u_index(i,j,k,nx));
      if(i<nx-1) printf(" %d", u_index(i+1,j,k,nx));
      if(j<nx-1) printf(" %d", u_index(i,j+1,k,nx));
      if(k<nx-1) printf(" %d", u_index(i,j,k+1,nx));
      printf(" %d %d\n", p_index(i-1,j,k,nx), p_index(i,j,k,nx));
   }
   printf("\n");
   // v columns
   for(k=0; k<nx; ++k) for(j=1; j<nx; ++j) for(i=0; i<nx; ++i){
      if(k>0) printf(" %d", v_index(i,j,k-1,nx));
      if(j>1) printf(" %d", v_index(i,j-1,k,nx));
      if(i>0) printf(" %d", v_index(i-1,j,k,nx));
      printf(" %d", v_index(i,j,k,nx));
      if(i<nx-1) printf(" %d", v_index(i+1,j,k,nx));
      if(j<nx-1) printf(" %d", v_index(i,j+1,k,nx));
      if(k<nx-1) printf(" %d", v_index(i,j,k+1,nx));
      printf(" %d %d\n", p_index(i,j-1,k,nx), p_index(i,j,k,nx));
   }
   printf("\n");
   // w columns
   for(k=1; k<nx; ++k) for(j=0; j<nx; ++j) for(i=0; i<nx; ++i){
      if(k>1) printf(" %d", w_index(i,j,k-1,nx));
      if(j>0) printf(" %d", w_index(i,j-1,k,nx));
      if(i>0) printf(" %d", w_index(i-1,j,k,nx));
      printf(" %d", w_index(i,j,k,nx));
      if(i<nx-1) printf(" %d", w_index(i+1,j,k,nx));
      if(j<nx-1) printf(" %d", w_index(i,j+1,k,nx));
      if(k<nx-1) printf(" %d", w_index(i,j,k+1,nx));
      printf(" %d %d\n", p_index(i,j,k-1,nx), p_index(i,j,k,nx));
   }
   printf("\n");
   // p columns
   for(k=0; k<nx; ++k) for(j=0; j<nx; ++j) for(i=0; i<nx; ++i){
      if(i>0) printf(" %d", u_index(i,j,k,nx));
      if(i<nx-1) printf(" %d", u_index(i+1,j,k,nx));
      if(j>0) printf(" %d", v_index(i,j,k,nx));
      if(j<nx-1) printf(" %d", v_index(i,j+1,k,nx));
      if(k>0) printf(" %d", w_index(i,j,k,nx));
      if(k<nx-1) printf(" %d", w_index(i,j,k+1,nx));
      printf("\n");
   }
   printf("\n");

   // and finally numerical entries
   // u columns
   for(k=0; k<nx; ++k) for(j=0; j<nx; ++j) for(i=1; i<nx; ++i){
      if(k>0) printf(" -1");
      if(j>0) printf(" -1");
      if(i>1) printf(" -1");
      printf(" 6");
      if(i<nx-1) printf(" -1");
      if(j<nx-1) printf(" -1");
      if(k<nx-1) printf(" -1");
      printf(" 1 -1\n");
   }
   printf("\n");
   // v columns
   for(k=0; k<nx; ++k) for(j=1; j<nx; ++j) for(i=0; i<nx; ++i){
      if(k>0) printf(" -1");
      if(j>1) printf(" -1");
      if(i>0) printf(" -1");
      printf(" 6");
      if(i<nx-1) printf(" -1");
      if(j<nx-1) printf(" -1");
      if(k<nx-1) printf(" -1");
      printf(" 1 -1\n");
   }
   printf("\n");
   // w columns
   for(k=1; k<nx; ++k) for(j=0; j<nx; ++j) for(i=0; i<nx; ++i){
      if(k>1) printf(" -1");
      if(j>0) printf(" -1");
      if(i>0) printf(" -1");
      printf(" 6");
      if(i<nx-1) printf(" -1");
      if(j<nx-1) printf(" -1");
      if(k<nx-1) printf(" -1");
      printf(" 1 -1\n");
   }
   printf("\n");
   // p columns
   for(k=0; k<nx; ++k) for(j=0; j<nx; ++j) for(i=0; i<nx; ++i){
      if(i>0) printf(" -1");
      if(i<nx-1) printf(" 1");
      if(j>0) printf(" -1");
      if(j<nx-1) printf(" 1");
      if(k>0) printf(" -1");
      if(k<nx-1) printf(" 1");
      printf("\n");
   }
   printf("\n");

   return 0;
}

